'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactStaticContainer = require('react-static-container');

var _reactStaticContainer2 = _interopRequireDefault(_reactStaticContainer);

var _ReadyState = require('./ReadyState');

var _ReadyState2 = _interopRequireDefault(_ReadyState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FetchReadyStateRenderer = function (_Component) {
  (0, _inherits3.default)(FetchReadyStateRenderer, _Component);

  function FetchReadyStateRenderer() {
    (0, _classCallCheck3.default)(this, FetchReadyStateRenderer);
    return (0, _possibleConstructorReturn3.default)(this, (FetchReadyStateRenderer.__proto__ || Object.getPrototypeOf(FetchReadyStateRenderer)).apply(this, arguments));
  }

  (0, _createClass3.default)(FetchReadyStateRenderer, [{
    key: 'renderChildrenIfNeeded',
    value: function renderChildrenIfNeeded() {
      var _props = this.props,
          children = _props.children,
          error = _props.error,
          readyState = _props.readyState,
          renderFailure = _props.renderFailure,
          renderSuccess = _props.renderSuccess,
          renderLoading = _props.renderLoading;


      if (readyState === _ReadyState2.default.PENDING || readyState === _ReadyState2.default.LOADING) {
        if (renderLoading) {
          return renderLoading();
        }
      } else if (readyState === _ReadyState2.default.FAILURE) {
        if (renderFailure) {
          return renderFailure(error);
        }
      } else if (readyState === _ReadyState2.default.SUCCESS) {
        if (renderSuccess) {
          return renderSuccess();
        }

        return children;
      }

      return undefined;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.renderChildrenIfNeeded();
      var shouldUpdate = true;

      if (typeof children === 'undefined') {
        shouldUpdate = false;
        children = null;
      }

      return _react2.default.createElement(
        _reactStaticContainer2.default,
        { shouldUpdate: shouldUpdate },
        children
      );
    }
  }]);
  return FetchReadyStateRenderer;
}(_react.Component);

FetchReadyStateRenderer.displayName = 'FetchReadyStateRenderer';

FetchReadyStateRenderer.propTypes = {
  children: _propTypes2.default.node,
  error: _propTypes2.default.any,
  readyState: _propTypes2.default.oneOf([_ReadyState2.default.FAILURE, _ReadyState2.default.LOADING, _ReadyState2.default.PENDING, _ReadyState2.default.SUCCESS]).isRequired,
  renderFailure: _propTypes2.default.func,
  renderLoading: _propTypes2.default.func,
  renderSuccess: _propTypes2.default.func
};

exports.default = FetchReadyStateRenderer;