'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FetchRootComponent = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var _selectors = require('./selectors');

var _FetchReadyStateRenderer = require('./FetchReadyStateRenderer');

var _FetchReadyStateRenderer2 = _interopRequireDefault(_FetchReadyStateRenderer);

var _ReadyState = require('./ReadyState');

var _ReadyState2 = _interopRequireDefault(_ReadyState);

var _isSameLocation = require('./isSameLocation');

var _isSameLocation2 = _interopRequireDefault(_isSameLocation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FetchRootContainer = function (_Component) {
  (0, _inherits3.default)(FetchRootContainer, _Component);

  function FetchRootContainer(props, context) {
    (0, _classCallCheck3.default)(this, FetchRootContainer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FetchRootContainer.__proto__ || Object.getPrototypeOf(FetchRootContainer)).call(this, props, context));

    _this.state = _this.getInitialState();
    return _this;
  }

  (0, _createClass3.default)(FetchRootContainer, [{
    key: 'getInitialState',
    value: function getInitialState() {
      return {
        readyState: this.props.readyState
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var forceInitialFetch = this.props.forceInitialFetch;
      var readyState = this.state.readyState;


      if (readyState === _ReadyState2.default.PENDING || forceInitialFetch) {
        this.fetchRouteData();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var prevLocation = this.props.routerProps.location;
      var nextLocation = nextProps.routerProps.location;

      if ((0, _isSameLocation2.default)(prevLocation, nextLocation)) {
        this.setState({ readyState: nextProps.readyState });
      } else {
        this.setState({ readyState: _ReadyState2.default.PENDING });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var readyState = this.state.readyState;


      if (readyState === _ReadyState2.default.PENDING) {
        this.fetchRouteData();
      }
    }
  }, {
    key: 'fetchRouteData',
    value: function fetchRouteData() {
      var _props = this.props,
          onFetchRouteData = _props.onFetchRouteData,
          routerProps = _props.routerProps;

      onFetchRouteData(routerProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          error = _props2.error,
          renderFailure = _props2.renderFailure,
          renderSuccess = _props2.renderSuccess,
          renderLoading = _props2.renderLoading;
      var readyState = this.state.readyState;


      return _react2.default.createElement(
        _FetchReadyStateRenderer2.default,
        {
          error: error,
          readyState: readyState,
          renderFailure: renderFailure,
          renderLoading: renderLoading,
          renderSuccess: renderSuccess },
        children
      );
    }
  }]);
  return FetchRootContainer;
}(_react.Component);

FetchRootContainer.displayName = 'FetchRootContainer';

FetchRootContainer.propTypes = {
  children: _propTypes2.default.node.isRequired,
  error: _propTypes2.default.any,
  forceInitialFetch: _propTypes2.default.bool,
  onFetchRouteData: _propTypes2.default.func.isRequired,
  readyState: _propTypes2.default.oneOf([_ReadyState2.default.FAILURE, _ReadyState2.default.LOADING, _ReadyState2.default.PENDING, _ReadyState2.default.SUCCESS]).isRequired,
  renderFailure: _propTypes2.default.func,
  renderLoading: _propTypes2.default.func,
  renderSuccess: _propTypes2.default.func,
  routerProps: _propTypes2.default.object.isRequired
};

FetchRootContainer.defaultProps = {
  forceInitialFetch: false
};

var mapStateToProps = function mapStateToProps(state) {
  return {
    error: (0, _selectors.getError)(state),
    readyState: (0, _selectors.getReadyState)(state)
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return (0, _redux.bindActionCreators)({
    onFetchRouteData: _actions.fetchRouteData
  }, dispatch);
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FetchRootContainer);
exports.FetchRootComponent = FetchRootContainer; // for testing