'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getIsFailure = exports.getIsSuccess = exports.getIsLoading = exports.getIsPending = exports.getError = exports.getReadyState = exports.getLocation = undefined;

var _ReadyState = require('./ReadyState');

var _ReadyState2 = _interopRequireDefault(_ReadyState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getLocation = exports.getLocation = function getLocation(state) {
  return state.fetch.location;
};
var getReadyState = exports.getReadyState = function getReadyState(state) {
  return state.fetch.readyState;
};
var getError = exports.getError = function getError(state) {
  return state.fetch.error;
};
var getIsPending = exports.getIsPending = function getIsPending(state) {
  return getReadyState(state) === _ReadyState2.default.PENDING;
};
var getIsLoading = exports.getIsLoading = function getIsLoading(state) {
  return getReadyState(state) === _ReadyState2.default.LOADING;
};
var getIsSuccess = exports.getIsSuccess = function getIsSuccess(state) {
  return getReadyState(state) === _ReadyState2.default.SUCCESS;
};
var getIsFailure = exports.getIsFailure = function getIsFailure(state) {
  return getReadyState(state) === _ReadyState2.default.FAILURE;
};